#ifndef __XTL__STACK__
#define __XTL__STACK__

#include <cstddef>

namespace xtl {

class stack {
public:
	explicit stack(size_t size);
	stack(stack &&) noexcept;
	stack & operator=(stack &&) noexcept;
	~stack() noexcept;

	void * get() const noexcept;
	size_t size() const noexcept;

private:
	size_t m_size;
	void * m_base;
	int m_valgrind_id;
};

} // namespace xtl

namespace xtl {

inline void * stack::get() const noexcept {
	return m_base;
}

inline size_t stack::size() const noexcept {
	return m_size;
}

} // namespace xtl

#endif
